
//
// flic (.flc) file format
//

#ifndef _flic_h_
#define _flic_h_

//
// defines
//

#define FLAG_RING	0x0001
#define FLAG_INITIAL	0x0002

#define TYPE_FLI	0xAF11
#define TYPE_FLC	0xAF12
#define TYPE_PREFIX	0xF100
#define TYPE_FRAME	0xF1FA

#define TYPE_COLOR_256	4
#define TYPE_DELTA_FLC	7
#define TYPE_COLOR_64	11
#define TYPE_DELTA_FLI	12
#define TYPE_BLACK	13
#define TYPE_BYTE_RUN	15
#define TYPE_FLI_COPY	16
#define TYPE_PSTAMP	18

//
// types
//

typedef unsigned char U1;
typedef unsigned short U2;
typedef unsigned long U4;
typedef signed char S1;
typedef signed short S2;
typedef signed long S4;

//
// structures
//

typedef struct
{
	U4 size;
	U2 type;
	U2 frames;
	U2 width;
	U2 height;
	U2 depth;
	U2 flags;
	U4 speed;
	U2 reserved1;
	U4 created;
	U4 creator;
	U4 updated;
	U4 updator;
	U2 aspect_dx;
	U2 aspect_dy;
	U1 reserved2[38];
	U4 oframe1;
	U4 oframe2;
	U1 reserved3[40];
} Header;

typedef struct
{
	U4 size;
	U2 type;
	U2 chunks;
	U1 reserved[8];
} Prefix;

typedef struct
{
	U4 size;
	U2 type;
	U2 chunks;
	U1 reserved[8];
} Frame;

typedef struct
{
	U4 size;
	U2 type;
} Chunk;

typedef struct
{
	char * buffer;
	Header * header;
	Prefix * prefix;
	Frame * * frames;
	PhImage_t * image;
	int index;
} Flic;

#endif
